//---------------------------------------------------------------------------
/*
Compute sun position and Muslims Salat times for particular date
Copyright (C) 2006  Lotfi BAGHLI

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

*********************************************************
*** IF YOU ARE MUSLIM, PLEASE PRAY FOR MY FORGIVENESS ***
*********************************************************

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
//---------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "mainroutines_extern.h"
//#define _CRT_SECURE_NO_DEPRECATE
#pragma warning( disable : 4996 4244)
//---------------------------------------------------------------------------
const double M_PI=3.1415926535897932384626433832795;
const double deg2rd = 0.017453292519943295769236907684886;
const double rd2deg = 57.295779513082320876798154814105;
const double SolarSiderealCorrection = 1.002738;

		struct Astre Soleil;
		struct SalatTimeStruct SalatTime, SalatTimeC;
		double JD, T,  // Jour Julien, Julien Century : T,
					theta0, theta,  // theta0 : temps sideral  Greenwich
					longitude, latitude;
		struct DateUT date; // date en jours
		struct Heure heure; // heure
		int TimeZone, TimeZoneTown, NTowns, TownSelected, Verbose, Convention;
		int DST, DSTApplies;
		struct SalatTimeConfigStruct SalatTimeConfig[NConvention];
pTownData * Towns;
		char * Mounths[]={"Janvier", "Fvrier", "Mars", "Avril",
									"Mai", "Juin", "Juillet", "Aot",
									"Septembre", "Octobre", "Novembre", "Dcembre"};
		char * Days[]={"Lundi", "Mardi", "Mercredi", "Jeudi", "Vendredi", "Samedi", "Dimanche"};
		char CountryName[Namelenght], TownName[Namelenght];

//---------------------------------------------------------------------------
// Algorithms from 	http://www.jgiesen.de/SME/details/basics/meeus.htm#solar
//								 	http://www.jgiesen.de/SME/details/basics/index.htm
//  								http://stjarnhimlen.se/comp/riset.html#3
//									http://www.ummah.net/astronomy/saltime/
// modified by Lotfi BAGHLI on 15/01/2006 et 10/06/2006
//---------------------------------------------------------------------------

// Julian day: 86400 s, Julian year: 365.25 d, Julian Century: 36525 d
// Julian Day (valid from 1900/3/1 to 2100/2/28)
double JulianDay (int date, int month, int year, double UT)
{
	if (month<=2) {month=month+12; year=year-1;}
	return (int)(365.25*year) + (int)(30.6001*(month+1)) - 15 + 1720996.5 + date + UT/24.0;
}
//---------------------------------------------------------------------------
// rang du jour
/*
double rang_du_jour (int date, int month, int year)
{                                                                                         
int N1, N2, K, N;
	N1=(month*275)/9;
	N2=(month+9)/12;
	K=1+ (year-4*(int)(year/4)+2)/3;
	(K=2 pour une anne commune et K=1 pour une bissextile)
	Le rang du jour est donn par :
	N=N1-N2*K+date-30;
	return N;
} pas ncessaire */
//---------------------------------------------------------------------------
// Julian century depuis 01/01/2000  12h UT
double JulianCentury (int date, int month, int year, double UT)
{
	if (month<=2) {month=month+12; year=year-1;}
  return ((int)(365.25*year) + (int)(30.6001*(month+1)) - 15 + 1720996.5 + date + UT/24.0 - 2451545.0)/36525;
} 
//---------------------------------------------------------------------------
//Solar Coordinates (according to: Jean Meeus: Astronomical Algorithms), accuracy of 0.01 degree 
double SoleilLongitude( double T)   // L
{
double M, L0, DL, L, Lm;
	M = 357.52910 + 35999.05030*T - 0.0001559*T*T - 0.00000048*T*T*T; // mean anomaly, degree
	L0 = 280.46645 + 36000.76983*T + 0.0003032*T*T; // mean longitude, degree 
	DL = (1.914600 - 0.004817*T - 0.000014*T*T)*sin(deg2rd*M)
				+ (0.019993 - 0.000101*T)*sin(deg2rd*2*M) + 0.000290*sin(deg2rd*3*M); 
	L=L0 + DL; // true longitude, deg sans modulo
	Lm=L-360*(int)(L/360);
	if (Lm<0)	Lm+=360;
	return Lm*deg2rd; // true longitude, rd 
}
//---------------------------------------------------------------------------
// convert ecliptic longitude L (rd) to right ascension RA and declination delta
void eclipticL2RA_delta( double T, double L, double * RA, double * delta)
{
double eps, X, Y, Z, R;
// old approxim  eps = deg2rd*23.43999; // obliquity of ecliptic
	eps = deg2rd*(23.4393 -0.013*T);	// obliquity of ecliptic
	X = cos(L); Y = cos(eps)*sin(L); Z = sin(eps)*sin(L); R = sqrt(1.0-Z*Z); 
	*delta = atan2(Z, R); // in rd 
	*RA = 2*atan2(Y, X+R); //  in rd 
}
//---------------------------------------------------------------------------
//compute sidereal time at Greenwich (according to: Jean Meeus: Astronomical Algorithms ) 
double TempsSideral( double T)   // theta0
{
	double theta0, theta0m;
//	T siecle julien depuis 2000
	theta0=280.46061837 + 360.98564736629*T*36525 + 0.000387933*T*T - T*T*T/38710000.0;
	theta0m=theta0-360*(int)(theta0/360);
	if (theta0m<0)	theta0m+=360;
	return theta0m*deg2rd;    // TempsSideralen rd
}
//---------------------------------------------------------------------------
//convert tau, delta to horizon coordinates of the observer (altitude h, azimuth az) , needs latitude : beta
void equatorial2horizontal( double beta, double tau, double delta, double * h, double * az)
{
	*h=asin( sin(beta)*sin(delta) + cos(beta)*cos(delta)*cos(tau));	// h en rd
	*az =atan2( -sin(tau), cos(beta)*tan(delta) - sin(beta)*cos(tau))-M_PI;	// az en rd du SUD
	if (*az<0)	*az+=2*M_PI;
}
//---------------------------------------------------------------------------
//convert rad en heure
double rd2heure( double angle)
{
	return (angle*12.0/M_PI);
}
//---------------------------------------------------------------------------
// check DST applies ou non
int CalcTimeZone( int a, int m, int j, int DST, int TimeZoneTown)
{      // ici on approxime TimeZoneTown avec TimeZone puisque a n'a pas d'importance
int jjdebut, jjfin, mmdebut, mmfin, ji, jour, JourToSwitch;
double T;
	if (DST==2) {JourToSwitch=4; mmdebut=4; mmfin=9;} // dernier vendredi d'avril / septembre
			else		{JourToSwitch=6; mmdebut=3; mmfin=10;}// dernier dimanche de mars / octobre
// recherchedernier dimanche de mars et dernier dimanche d'octobre
// DST applys 26-Mar, 02:00h    29-Oct, 03:00h   pour 2006
	for (ji=31; ji>24; ji--)
		{
		T=JulianCentury (ji, mmdebut, a, 12);    // pour 12h
		jour=CalculeJour(T+(TimeZoneTown+12)/24.0/36525.0);
		if (jour==JourToSwitch) 	{	jjdebut=ji; ji=0; // dimanche  et on sort de la for
															}
		}
	for (ji=31; ji>24; ji--)
		{
		T=JulianCentury (ji, mmfin, a, 12);    // pour 12h
		jour=CalculeJour(T+(TimeZoneTown+12)/24.0/36525.0);
		if (jour==JourToSwitch) 	{	jjfin=ji; ji=0; // dimanche  et on sort de la for
															}
		}
	if (m>mmdebut && m<mmfin)	return true;
	if (m==mmdebut && j>=jjdebut)	return true;
	if (m==mmfin && j<jjfin)	return true;
	return false;
}
//---------------------------------------------------------------------------
//convert heure en rad
double heure2rd( double heure)
{
	return (heure*M_PI/12.0);
}
//---------------------------------------------------------------------------
//convert rad en deg min sec
char * rd2degminsec( double angle, char * SS)
{
double h, m, s;
int hi, mi;
	h=angle*rd2deg;
	hi=h;
	m=(h-hi)*60;
	mi=(h-hi)*60;
	s=(m-mi)*60;
	if (s+0.1>=60.0) 	{
										s=00.0;
										mi++;
										if (mi+0.1>=60.0) {
																			mi-=60.0;
																			hi++;
																			}
										}
	sprintf (SS,"%3d%02d'%02.0f\"", hi, mi,s);
	return SS;
}
//---------------------------------------------------------------------------
//convert rad en h min sec
char * rd2hminsec( double angle, char * SS)
{
double h, m, s;
int hi, mi;
	h=rd2heure(angle);
	hi=h;
	m=(h-hi)*60;
	mi=(h-hi)*60;
	s=(m-mi)*60;
	sprintf (SS,"%02dh%02d'%02.0f\"", hi, mi,s);
	return SS;
}
//---------------------------------------------------------------------------
//convert h en h min sec
char * h2hminsec( double h, char * SS)
{
double m, s;
int hi, mi;
	hi=h;
	m=(h-hi)*60;
	mi=(h-hi)*60;
	s=(m-mi)*60;
	sprintf (SS,"%02dh%02d'%02.0f\"", hi, mi,s);
	return SS;
}
//---------------------------------------------------------------------------
//convert h en h min arondie
char * h2hmiarrondie( double h, char * SS)
{
double m, s;
int hi, mi;
	hi=h;
	m=(h-hi)*60;
	mi=(h-hi)*60;
	s=(m-mi)*60;
	if (s>=30)	{
							mi++;
							if (mi==60)	{
													mi=0; hi++;
													if (hi==24) { //alrs pb . on passe au jour suivant.. qui n'arrive jamais
																			sprintf(SS, "erreur : arrondi au jour suivant");
																			return SS;
						                          }	
													}
							}
	sprintf(SS, "%02d:%02d",hi,mi);
	return SS;
}
//---------------------------------------------------------------------------
//saisi la date
struct DateUT GetDate()
{
	printf("Entrez la date d'observation (d/m/a)\n");
//	scanf("%d/%d/%d", & date.j, & date.m, & date.a);
// debug
	date.j=7; date.m=6; date.a=2009;
	printf("Date saisie : %d/%d/%d)\n", date.j, date.m, date.a);
	return date;
}
//---------------------------------------------------------------------------
//saisi l'heure
struct Heure GetHeure()
{
	printf("Entrez l'heure d'observation (h/m/s)\n");
//	scanf("%d/%d/%d", & heure.h, & heure.m, & heure.s);
// debug
	heure.h=12; heure.m=00; heure.s=00;
	printf("Date saisie : %d/%d/%d\n", heure.h, heure.m, heure.s);
	heure.ms=0;
	return heure;
}
//---------------------------------------------------------------------------
// 		 ex	TFormMain
//---------------------------------------------------------------------------
void init()
{
//	Verbose=true;
	// initialisation...
	ReadConfigFile();
	if (Verbose) printf("Date : %d/%d/%d\n", date.j, date.m, date.a);
//	DatePicker->DateTime=Now();
//	TimePicker->DateTime=Now();
}
//---------------------------------------------------------------------------
void ComputeZuhrHour()
{
double Z_GMT, GMST0;
char SS[SSlenght];
	T=JulianCentury (date.j, date.m, date.a, 12);    // pour 12h
	if (Verbose)	printf("T=%g  JC  12h GMT\n",T);
	Soleil.L=SoleilLongitude(T);
	eclipticL2RA_delta( T, Soleil.L, & Soleil.RA, & Soleil.delta);
	theta0=TempsSideral( T);
	GMST0=theta0-heure2rd(12);
	Z_GMT=rd2heure(Soleil.RA-GMST0-longitude);
// iteration bis
	if (Z_GMT<0) 	{// si ngatif, on se place  j-1
								Z_GMT+=24;
								T=JulianCentury (date.j-1, date.m, date.a, Z_GMT+24);    // pour LA vraie heure  GWT
								}
		else				T=JulianCentury (date.j, date.m, date.a, Z_GMT);    // pour LA vraie heure  GWT
	if (Verbose)	printf("T=%g JC  %s\n",T, h2hminsec(Z_GMT, SS));
	Soleil.L=SoleilLongitude(T);
	eclipticL2RA_delta( T, Soleil.L, & Soleil.RA, & Soleil.delta);
	theta0=TempsSideral( T);
	GMST0=theta0-heure2rd(Z_GMT);
	SalatTime.Zuhr=TimeZone+rd2heure(Soleil.RA-GMST0-longitude);    // on le prend avec TimeZone
	if (SalatTime.Zuhr<0) SalatTime.Zuhr+=24;
}
//---------------------------------------------------------------------------
//compute pour une des 5 prieres
int ComputeTwilightHour(int TypeSalat, double * SalatHour)
{
double costau;
int Offset;
char SS[SSlenght];
	* SalatHour=0;
	switch (TypeSalat)
		{
		case idFajr : Soleil.h=-SalatTimeConfig[Convention].FajrTwilightAngle*deg2rd;
									Offset=-1;
									break;
		case idIsha : Soleil.h=-SalatTimeConfig[Convention].IshaTwilightAngle*deg2rd;
									Offset=+1;
									break;
		case idChourouk : Soleil.h=-SalatTimeConfig[Convention].Sunrise_setAngle*deg2rd;
									Offset=-1;
									break;
		case idMaghrib : Soleil.h=-SalatTimeConfig[Convention].Sunrise_setAngle*deg2rd;
									Offset=+1;
									break;
		}
	// commence par calculer au milieur de la journe le T et declinaison du soleil
	// iteration 1
	if (Verbose)	printf(" 1st iter %s\n", h2hminsec(SalatTime.Zuhr-TimeZone, SS));
	T=JulianCentury (date.j, date.m, date.a, SalatTime.Zuhr-TimeZone);    // pour LA vraie heure  GWT
	if (Verbose)		printf("T=%g JC  %s\n", T, h2hminsec(SalatTime.Zuhr-TimeZone, SS));
	Soleil.L=SoleilLongitude(T);
	eclipticL2RA_delta( T, Soleil.L, & Soleil.RA, & Soleil.delta);
	if (TypeSalat==idAsr)		{
													if (SalatTimeConfig[Convention].AsrShafi)		Soleil.h=atan(1.0/(1.0+tan(latitude-Soleil.delta)));   // Asr Shafi : length of shadow = length of object + noon shadow
																else			Soleil.h=atan(1.0/(2.0+tan(latitude-Soleil.delta)));   // Asr Hanafi : length of shadow =2x length of object + noon shadow
													Offset=+1;
													}
	costau =(sin(Soleil.h)- sin(latitude)*sin(Soleil.delta))/cos(latitude)/cos(Soleil.delta);
	if (Verbose)	printf(" costau=%g\n",costau);
	if (costau>1.0)		{if (Verbose)	printf("ERROR : then the Sun is always above our altitude limit. If we were computing rise/set times, the Sun is then aboute the horizon continuously; we have Midnight Sun.\n");
										return 1;}
	if (costau<-1.0)	{if (Verbose)	printf("ERROR : then the Sun is always below our altitude limit. One example is midwinter in the arctics, when the Sun never gets above the horizon.\n");
										return -1;}
	if (costau>=-1.0 && costau<=1.0)
			{
			Soleil.tau=acos(costau)/SolarSiderealCorrection;
			* SalatHour=SalatTime.Zuhr + Offset*rd2heure(Soleil.tau);
			if (Verbose)	printf(" SalatHour=%gh ie : %s\n", * SalatHour, h2hminsec(* SalatHour, SS));
			}
// corrected values, avec iterations
	if (Verbose)	printf("** corrected values ** :\n");
	// iteration 2
	if (Verbose)	printf(" 2nd iter  %s\n", h2hminsec(* SalatHour-TimeZone, SS));
	T=JulianCentury (date.j, date.m, date.a, * SalatHour-TimeZone);    // pour LA vraie heure  GWT
	if (Verbose)	printf("T=%g JC  %s\n", T, h2hminsec(* SalatHour-TimeZone, SS));
	Soleil.L=SoleilLongitude(T);
	eclipticL2RA_delta( T, Soleil.L, & Soleil.RA, & Soleil.delta);
	if (TypeSalat==idAsr)		{
													if (SalatTimeConfig[Convention].AsrShafi)		Soleil.h=atan(1.0/(1.0+tan(latitude-Soleil.delta)));   // Asr Shafi : length of shadow = length of object + noon shadow
																else			Soleil.h=atan(1.0/(2.0+tan(latitude-Soleil.delta)));   // Asr Hanafi : length of shadow =2x length of object + noon shadow
													}
//	theta0=TempsSideral( T);
//	GMST0=theta0-heure2rd(* SalatHour-TimeZone);
 	costau =(sin(Soleil.h)- sin(latitude)*sin(Soleil.delta))/cos(latitude)/cos(Soleil.delta);
	if (Verbose)	printf(" costau=%g\n",costau);
	if (costau>1.0)		{if (Verbose)	printf("ERROR : then the Sun is always above our altitude limit. If we were computing rise/set times, the Sun is then aboute the horizon continuously; we have Midnight Sun.\n");
										return 1;}
	if (costau<-1.0)	{if (Verbose)	printf("ERROR : then the Sun is always below our altitude limit. One example is midwinter in the arctics, when the Sun never gets above the horizon.\n");
										return -1;}
	if (costau>=-1.0 && costau<=1.0)
			{
			Soleil.tau=acos(costau); ///SolarSiderealCorrection; pas pour les suivants
			* SalatHour=SalatTime.Zuhr + Offset*rd2heure(Soleil.tau);
			if (Verbose)	printf(" SalatHour=%gh ie : %s\n", * SalatHour, h2hminsec(* SalatHour, SS));
			}
	// iteration 3
	if (Verbose)	printf(" 3rd iter  %s\n", h2hminsec(* SalatHour-TimeZone, SS));
	T=JulianCentury (date.j, date.m, date.a, * SalatHour-TimeZone);    // pour LA vraie heure  GWT
	if (Verbose)	printf("T=%g JC  %s\n", T, h2hminsec(* SalatHour-TimeZone, SS));
	Soleil.L=SoleilLongitude(T);
	eclipticL2RA_delta( T, Soleil.L, & Soleil.RA, & Soleil.delta);
	if (TypeSalat==idAsr)		{
													if (SalatTimeConfig[Convention].AsrShafi)		Soleil.h=atan(1.0/(1.0+tan(latitude-Soleil.delta)));   // Asr Shafi : length of shadow = length of object + noon shadow
																else			Soleil.h=atan(1.0/(2.0+tan(latitude-Soleil.delta)));   // Asr Hanafi : length of shadow =2x length of object + noon shadow
													if (Verbose)	printf("h=%g  ie altitude %g\n", Soleil.h*rd2deg, rd2degminsec(Soleil.h, SS));
													}
//	theta0=TempsSideral( T);
//	GMST0=theta0-heure2rd(* SalatHour-TimeZone);
	costau =(sin(Soleil.h)- sin(latitude)*sin(Soleil.delta))/cos(latitude)/cos(Soleil.delta);
	if (Verbose)	printf(" costau=%g\n",costau);
	if (costau>1.0)		{if (Verbose)	printf("ERROR : then the Sun is always above our altitude limit. If we were computing rise/set times, the Sun is then aboute the horizon continuously; we have Midnight Sun.\n");
										return 1;}
	if (costau<-1.0)	{if (Verbose)	printf("ERROR : then the Sun is always below our altitude limit. One example is midwinter in the arctics, when the Sun never gets above the horizon.\n");
										return -1;}
	if (costau>=-1.0 && costau<=1.0)
			{
			Soleil.tau=acos(costau); ///SolarSiderealCorrection; pas pour les suivants
			* SalatHour=SalatTime.Zuhr + Offset*rd2heure(Soleil.tau);
			if (Verbose)	printf(" SalatHour=%gh ie : %s\n", * SalatHour, h2hminsec(* SalatHour, SS));
			}
	return 0;
}
//---------------------------------------------------------------------------
//Appelle les 2 methodes prcdentes pour calculer ttes les prieres
void ComputeSalatTime()
{
int erreur;
char SS[SSlenght], SS2[SSlenght];
	// manuel : date=GetDate();
	DSTApplies=(DST !=0) && CalcTimeZone(date.a, date.m, date.j, DST, TimeZoneTown);
	if (DSTApplies) TimeZone=1+TimeZoneTown;
						else  TimeZone=TimeZoneTown;
	if (Verbose)	printf("_____________________________________________________________\n");
	if (Verbose) 	printf("Lieu : %s, %s\n", CountryName,  TownName);
	if (Verbose) 	printf("latitude=%s   longitude=%s\n", rd2degminsec(latitude, SS),rd2degminsec(longitude, SS2));
	if (Verbose) 	printf((DSTApplies ? "DST Applies": "DST does not apply\n"));
	if (Verbose) 	printf("Convention %d\n", Convention);
	if (Verbose)	printf("____ Mawakit Salat _____\n");
	if (Verbose)	printf(" at Date=: %d/%d/%d   TZ=%d\n", date.j, date.m, date.a, TimeZone);
	// Calcul Zuhr
	ComputeZuhrHour();
	if (Verbose)	printf("Passage au mridien (Zuhr)=%gh ie : %s\n", SalatTime.Zuhr, h2hminsec(SalatTime.Zuhr, SS));
	if (Verbose)	printf("\n");
	// lever / coucher
	if (Verbose)	printf("Sunrise / Sunset at -%g", SalatTimeConfig[Convention].Sunrise_setAngle);
	// Calcul Chourouk (lever)
	erreur=ComputeTwilightHour( idChourouk, & SalatTime.Chourouk);
	if (Verbose)	printf("Chourouk (Sunrise) at %gh ie : %s\n", SalatTime.Chourouk, h2hminsec(SalatTime.Chourouk, SS));
	if (Verbose)	printf("\n");
	// Calcul Maghrib (coucher)
	erreur=ComputeTwilightHour( idMaghrib, & SalatTime.Maghrib);
	if (Verbose)	printf("Maghrib (Sunset) at %gh ie : %s\n", SalatTime.Maghrib, h2hminsec(SalatTime.Maghrib, SS));
	if (Verbose)	printf("\n");
	// Calcul Fajr (Twilight)
	erreur=ComputeTwilightHour( idFajr, & SalatTime.Fajr);
	if (Verbose)	printf("Fajr (Twilight) at %gh ie : %s\n", SalatTime.Fajr, h2hminsec(SalatTime.Fajr, SS));
	if (Verbose)	printf("\n");
	// Calcul Isha (Twilight) or Maghrib+
	if (SalatTimeConfig[Convention].Isha_is_Maghrib_plus)
						SalatTime.Isha=SalatTime.Maghrib + SalatTimeConfig[Convention].Isha_is_Maghrib_plus_min/60.0;
			else	erreur=ComputeTwilightHour( idIsha, & SalatTime.Isha);
	if (Verbose)	{
								if (SalatTimeConfig[Convention].Isha_is_Maghrib_plus)
											printf("Isha (Maghrib_plus %dmn) at %gh ie : %s\n", SalatTimeConfig[Convention].Isha_is_Maghrib_plus_min, SalatTime.Isha, h2hminsec(SalatTime.Isha, SS));
											else printf("Isha (Twilight) at %gh ie : %s\n", SalatTime.Isha, h2hminsec(SalatTime.Isha, SS));
								}
	if (Verbose)	printf("\n");
	// Calcul Asr (arccot(1+tan(B-D)))
	erreur=ComputeTwilightHour( idAsr, & SalatTime.Asr);
	if (Verbose)	printf("Asr (%s) at %gh ie : %s\n", SalatTimeConfig[Convention].AsrShafi>=0 ? "Shafi":"Hanafi", SalatTime.Asr, h2hminsec(SalatTime.Asr, SS));
	if (Verbose)	printf("\n");

	// calcule les vraies heures de prire
	SalatTimeC.Fajr=SalatTime.Fajr +SalatTimeConfig[Convention].SalatTimeAdjust.Fajr/60.0;
	SalatTimeC.Chourouk=SalatTime.Chourouk +SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk/60.0;
	if (SalatTimeConfig[Convention].ZuhrFixe)	SalatTimeC.Zuhr=SalatTimeConfig[Convention].ZuhrFixeHour;
			else SalatTimeC.Zuhr=SalatTime.Zuhr +SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr/60.0;
	SalatTimeC.Asr=SalatTime.Asr +SalatTimeConfig[Convention].SalatTimeAdjust.Asr/60.0;
	SalatTimeC.Maghrib=SalatTime.Maghrib +SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib/60.0;
	SalatTimeC.Isha=SalatTime.Isha  +SalatTimeConfig[Convention].SalatTimeAdjust.Isha/60.0;
	if (Verbose)	printf("_______ Mawakit Salat Exactes _______\n");
	if (Verbose)	printf("Fajr    =%s%s%gmn  %s\n", h2hminsec(SalatTime.Fajr, SS), SalatTimeConfig[Convention].SalatTimeAdjust.Fajr>=0 ? " +":" ", SalatTimeConfig[Convention].SalatTimeAdjust.Fajr, h2hminsec(SalatTimeC.Fajr, SS2));
	if (Verbose)	printf("Chourouk=%s%s%gmn  %s\n", h2hminsec(SalatTime.Chourouk, SS), SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk>=0 ? " +":" ", SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk, h2hminsec(SalatTimeC.Chourouk, SS2));
	if (Verbose)	{
								if (SalatTimeConfig[Convention].ZuhrFixe)	printf("Zuhr Fixed = %s\n", h2hminsec(SalatTimeC.Zuhr, SS));
									else printf("Zuhr    =%s%s%gmn  %s\n", h2hminsec(SalatTime.Zuhr, SS), SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr>=0 ? " +":" ", SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr, h2hminsec(SalatTimeC.Zuhr, SS2));
								}
	if (Verbose)	printf("Asr     =%s%s%gmn  %s\n", h2hminsec(SalatTime.Asr, SS), SalatTimeConfig[Convention].SalatTimeAdjust.Asr>=0 ? " +":" ", SalatTimeConfig[Convention].SalatTimeAdjust.Asr, h2hminsec(SalatTimeC.Asr, SS2));
	if (Verbose)	printf("Maghrib =%s%s%gmn  %s\n", h2hminsec(SalatTime.Maghrib, SS), SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib>=0 ? " +":" ", SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib, h2hminsec(SalatTimeC.Maghrib, SS2));
	if (Verbose)	printf("Isha    =%s%s%gmn  %s\n", h2hminsec(SalatTime.Isha, SS), SalatTimeConfig[Convention].SalatTimeAdjust.Isha>=0 ? " +":" ", SalatTimeConfig[Convention].SalatTimeAdjust.Isha, h2hminsec(SalatTimeC.Isha, SS2));
	if (Verbose)	printf("_______ Mawakit Salat arrondi _______\n");

	if (Verbose) 	printf("Lieu : %s, %s\n", CountryName, TownName);
	if (Verbose) 	printf("latitude=%s   longitude=%s Convention %d\n", rd2degminsec(latitude, SS), rd2degminsec(longitude, SS2), Convention);
	if (Verbose)	printf("__ Date : %s %d/%d/%d   %s  TZ (include DST)=%d\n", Days[CalculeJour(T+(TimeZone+12)/24.0/36525.0)], date.j, date.m, date.a,
																																DSTApplies ? "DST Applies": "DST does not apply", TimeZone);
	if (Verbose)	printf("Fajr    =%s\n", h2hmiarrondie(SalatTimeC.Fajr, SS));
	if (Verbose)	printf("Chourouk=%s\n", h2hmiarrondie(SalatTimeC.Chourouk, SS));
	if (Verbose)	printf("Zuhr    =%s\n", h2hmiarrondie(SalatTimeC.Zuhr, SS));
	if (Verbose)	printf("Asr     =%s\n", h2hmiarrondie(SalatTimeC.Asr, SS));
	if (Verbose)	printf("Maghrib =%s\n", h2hmiarrondie(SalatTimeC.Maghrib, SS));
	if (Verbose)	printf("Isha    =%s\n", h2hmiarrondie(SalatTimeC.Isha, SS));
	if (Verbose)	printf("_____________________________________\n");
}
//---------------------------------------------------------------------------
void ButtonCalc_hazClick()
{
char SS[SSlenght], SS2[SSlenght];
int DSTApplies;
	// manuel : date=GetDate();
	// manuel : heure=GetHeure();
 // debug
	DSTApplies=(DST !=0) && CalcTimeZone(date.a, date.m, date.j, DST, TimeZoneTown);
	if (DSTApplies) TimeZone=1+TimeZoneTown;
						else  TimeZone=TimeZoneTown;
	if (Verbose)	printf("_____________________________________________________________\n");
	if (Verbose) 	printf("Lieu : %s, %s\n", CountryName, TownName);
	if (Verbose) 	printf("latitude=%g   longitude=%g\n", latitude*rd2deg, longitude*rd2deg);
	if (Verbose) 	printf("latitude=%s   longitude=%s\n", rd2degminsec(latitude, SS), rd2degminsec(longitude, SS2));
//???  if (date.j<0) {date.j+=???; date.m--}
	date.h=heure.h-TimeZone+heure.m/60.0+heure.s/3600.0;
	if (date.h<0) {date.h+=24; date.j--;}
// debug  fin
	if (Verbose)	printf("__ Date : %s %d/%d/%d  %gh UT   %s  TZ (include DST)=%d\n", Days[CalculeJour(T+(TimeZone+12)/24.0/36525.0)], date.j, date.m, date.a,
																									date.h, DSTApplies ? "DST Applies": "DST does not apply", TimeZone);
	if (Verbose)	printf("__ heure : %02d:%02d:%02d locale\n", heure.h, heure.m, heure.s);

	T=JulianCentury (date.j, date.m, date.a, date.h);
	if (Verbose)	printf("T=%g JC\n",T);

	Soleil.L=SoleilLongitude(T);
	if (Verbose) printf("Soleil Longitude L=%g ie : %s\n", Soleil.L*rd2deg, rd2hminsec(Soleil.L, SS));
  eclipticL2RA_delta( T, Soleil.L, & Soleil.RA, & Soleil.delta);
  theta0=TempsSideral( T);
	theta=theta0+longitude;
	if (Verbose) printf("theta0=%g ie : %s\n", theta0*rd2deg, rd2hminsec(theta0, SS));
	if (Verbose) printf("theta=%g  ie heure sidrale %s\n", theta*rd2deg, rd2hminsec(theta, SS));
	Soleil.tau=theta-Soleil.RA;
	if (Verbose) printf("RA=%g ie : %s\n", Soleil.RA*rd2deg, rd2hminsec(Soleil.RA, SS));
	if (Verbose) printf("delta=%g  ie DE %s\n", Soleil.delta*rd2deg, rd2degminsec(Soleil.delta, SS));
	if (Verbose) printf("tau=%g  ie angle horaire %s\n", Soleil.tau*rd2deg, rd2hminsec(Soleil.tau, SS));
	equatorial2horizontal( latitude, Soleil.tau, Soleil.delta, & Soleil.h, & Soleil.az);
	if (Verbose) printf("az=%g (orgine Sud) ie : azimut %s\n", Soleil.az*rd2deg, rd2degminsec(Soleil.az, SS));
	if (Verbose) printf("------az=%g (orgine Nord) ie -180 : azimut %s\n", Soleil.az*rd2deg-180, rd2degminsec(Soleil.az-M_PI, SS));
	if (Verbose) printf("h=%g  ie altitude %s\n", Soleil.h*rd2deg, rd2degminsec(Soleil.h, SS));
}
//---------------------------------------------------------------------------
void Oneday1Click()
{
	printf("\n");
	ComputeSalatTime();
}
//---------------------------------------------------------------------------
void ReadConfigFile()
{
char FileName[]="data.cfg";
char SS[SSlenght], SS2[SSlenght];
int iAsr, iIsha_is_Maghrib_plus, iZuhrFixe, TownsCount=0;
char * p;
long curpos;
struct TownData * ATown;
FILE * DataFile, * EchoFile;
int Code;
char Comment[201];
	if( (DataFile=fopen( FileName, "r")) == NULL )
			 {
			 printf("File open error %s\n", FileName);
			 return;
			 }
	if( (EchoFile=fopen( "read_echo.cfg", "w")) == NULL )
			{
			printf("read_echo.cfg file open error\n");
			return;
			}
	fprintf(EchoFile,"%s\n", "8 -----------------  File reading transcription  ---------------");
	while ( fscanf(DataFile,"%d", & Code) !=EOF)
	{
//	if (::GetAsyncKeyState(VK_ESCAPE) & 0x8000 ) 	break;
										// ie sort de la boucle
	fprintf(EchoFile, "%d ", Code);

	switch ( Code)
	 {
//8 - Conventions
//8 Convention Name
	case 5 :
		fscanf( DataFile,"%d", & Convention);
//		DataFile.getline( Comment, 200, '\n');
		fgets( Comment, 200, DataFile);
		p=strtok(Comment,"\"");
		p=strtok(NULL,"\"");
		strcpy( SalatTimeConfig[Convention].Name, strtok(p,"\""));
		fprintf(EchoFile, "%-9d \"%s\"\n", Convention, SalatTimeConfig[Convention].Name);
//		EchoFile  <<setw( 9)<< Convention <<"  \"" <<SalatTimeConfig[Convention].Name <<"\"\n";
		break;
//8 Convention AsrSahfi/Hanafi FajrTwilightAngle IshaTwilightAngle Sunrise/SetAngle Isha_is_Maghrib_plus xx mn ZuhrFixe ZuhrHour(h)
	case 3 :
		fscanf( DataFile,"%d", & Convention);
		fscanf( DataFile,"%d %lf %lf %lf %d %d %d %lf\n", & iAsr, & SalatTimeConfig[Convention].FajrTwilightAngle, & SalatTimeConfig[Convention].IshaTwilightAngle,
								& SalatTimeConfig[Convention].Sunrise_setAngle,
								& iIsha_is_Maghrib_plus, & SalatTimeConfig[Convention].Isha_is_Maghrib_plus_min,
								& iZuhrFixe, & SalatTimeConfig[Convention].ZuhrFixeHour);
//		DataFile >> iAsr >> SalatTimeConfig[Convention].FajrTwilightAngle >> SalatTimeConfig[Convention].IshaTwilightAngle
//						 >> SalatTimeConfig[Convention].Sunrise_setAngle
//						 >> iIsha_is_Maghrib_plus >> SalatTimeConfig[Convention].Isha_is_Maghrib_plus_min
//						 >> iZuhrFixe >> SalatTimeConfig[Convention].ZuhrFixeHour;
		fprintf(EchoFile, "%-9d  %-14d  %-16g  %-16g  %-15g  %-19d  %-4d  %-7d  %-15.7f\n", Convention, iAsr,
						SalatTimeConfig[Convention].FajrTwilightAngle, SalatTimeConfig[Convention].IshaTwilightAngle,
						SalatTimeConfig[Convention].Sunrise_setAngle,
						iIsha_is_Maghrib_plus, SalatTimeConfig[Convention].Isha_is_Maghrib_plus_min,
						iZuhrFixe, SalatTimeConfig[Convention].ZuhrFixeHour);
//		EchoFile  <<setw( 9)<< Convention <<"  " <<setw( 14)<< iAsr <<"  "
//			<<setw( 16)<< SalatTimeConfig[Convention].FajrTwilightAngle <<"  " <<setw( 16)<< SalatTimeConfig[Convention].IshaTwilightAngle <<"  "
//			<<setw( 15)<< SalatTimeConfig[Convention].Sunrise_setAngle  <<"  "
//			<<setw( 19)<< iIsha_is_Maghrib_plus  <<"  " <<setw( 4)<< SalatTimeConfig[Convention].Isha_is_Maghrib_plus_min  <<"  "
//			<<setw( 7)<< iZuhrFixe  <<"  " <<setw( 15)<< SalatTimeConfig[Convention].ZuhrFixeHour  <<"\n";
		SalatTimeConfig[Convention].AsrShafi=(iAsr==1);
		SalatTimeConfig[Convention].Isha_is_Maghrib_plus=(iIsha_is_Maghrib_plus==1);
		SalatTimeConfig[Convention].ZuhrFixe=(iZuhrFixe==1);
		break;
//- Time (mn) to add to get Salat
//8 Convention Fajr  Chourouk  Zuhr  Asr  Maghrib  Isha
	case 4 :
		fscanf( DataFile,"%d", & Convention);
		fscanf( DataFile,"%lf %lf %lf %lf %lf %lf\n", & SalatTimeConfig[Convention].SalatTimeAdjust.Fajr, & SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk,
						& SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr, & SalatTimeConfig[Convention].SalatTimeAdjust.Asr,
						& SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib, & SalatTimeConfig[Convention].SalatTimeAdjust.Isha);
//		DataFile >> Convention;
//		DataFile >> SalatTimeConfig[Convention].SalatTimeAdjust.Fajr >> SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk >> SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr
//						>> SalatTimeConfig[Convention].SalatTimeAdjust.Asr >> SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib >> SalatTimeConfig[Convention].SalatTimeAdjust.Isha;
		fprintf(EchoFile, "%-9d  %-7g  %-7g  %-7g  %-7g  %-7g  %-7g\n", Convention, SalatTimeConfig[Convention].SalatTimeAdjust.Fajr, SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk,
						SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr, SalatTimeConfig[Convention].SalatTimeAdjust.Asr,
						SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib, SalatTimeConfig[Convention].SalatTimeAdjust.Isha);
//		EchoFile  <<setw( 9)<< Convention <<"  " <<setw( 7)<< SalatTimeConfig[Convention].SalatTimeAdjust.Fajr  <<"  " <<setw( 7)<< SalatTimeConfig[Convention].SalatTimeAdjust.Chourouk  <<"  "
//			<<setw( 7)<< SalatTimeConfig[Convention].SalatTimeAdjust.Zuhr  <<"  " <<setw( 7)<< SalatTimeConfig[Convention].SalatTimeAdjust.Asr  <<"  "
//			<<setw( 7)<< SalatTimeConfig[Convention].SalatTimeAdjust.Maghrib  <<"  " <<setw( 7)<<SalatTimeConfig[Convention].SalatTimeAdjust.Isha  <<"\n";
		break;
//8 NumberOfTowns  TownSelected  Verbose
	case 1 :
		fscanf( DataFile,"%d %d %d\n", & NTowns, & TownSelected, & Verbose);
//		DataFile >> NTowns >> TownSelected >> Verbose;
		fprintf(EchoFile, "%-13d  %-12d  %-7d\n", NTowns, TownSelected, Verbose);
//		EchoFile  <<setw( 13)<< NTowns <<"  " <<setw( 12)<< TownSelected <<"  "
//			<< setw( 7)<< Verbose <<"\n";
		if (NTowns<=0) {
					printf ("Read config file Error : Invalid number of towns.\n");
					}
//		if (Towns!=NULL)	delete[] Towns;
		Towns=malloc(sizeof(struct TownData *)*NTowns); //Towns=new pTownData[NTowns];
		break;
//8 - Town location and TimeZone
//8 Country   Name            latitude   longitude TimeZone DST
	case 2 :
		ATown=malloc((1)* sizeof(struct TownData)); //ATown=new TownData;
		fscanf( DataFile,"%s %s %lf %lf %d %d %d\n", & ATown->CountryName, & ATown->TownName,
						& ATown->latitude, & ATown->longitude,
						& ATown->TimeZoneTown, & ATown->DST, & ATown->Convention);
//		DataFile >> ATown->CountryName >> ATown->TownName
//						 >> ATown->latitude >> ATown->longitude
//						 >> ATown->TimeZoneTown >> ATown->DST >> ATown->Convention;
		fprintf(EchoFile, "%-15s  %-15s  %-10lf  %-10lf  %-7d  %-2d  %-2d\n", ATown->CountryName, ATown->TownName,
						ATown->latitude, ATown->longitude,
						ATown->TimeZoneTown, ATown->DST, ATown->Convention);
//		EchoFile  <<setw( 15)<< ATown->CountryName <<"  " <<setw( 15)<<  ATown->TownName
//			<<setw( 10)<< ATown->latitude <<"  " <<setw( 10)<<  ATown->longitude
//			<<setw( 7)<< ATown->TimeZoneTown  <<"  " <<setw( 2)<<  ATown->DST <<"  "
//			<<setw( 2)<< ATown->Convention  <<"\n";
		Towns[TownsCount]=ATown;
		TownsCount++;
		break;
// Commentaire
	 case 8 :
		fgets( Comment, 200, DataFile);
//		fseek( EchoFile, -1, SEEK_END);
   curpos = ftell(EchoFile);
	 fseek(EchoFile, curpos-1, SEEK_SET);
//	EchoFile.seekp( EchoFile.tellp()-1 );
		fprintf(EchoFile, "%s", Comment);
		break;

		default :
		printf("ReadError !!! on %s\n", FileName);
		return;
		}   // switch

	}  // while
	fclose( DataFile);
	// Ferme aussi le fichier de sortie rd_echo.dat
	fclose( EchoFile);
	if (NTowns != TownsCount) {
				printf("Number of towns does not match NTowns\n");
				return;
				}

//ajouter aus Items de Listes des 2 form dialog
//	FormTowns->LBConvention->Items->Clear();
//	FormSettings->LBConvention->Items->Clear();
//	for (i=0; i<NConvention; i++)
//		{
//		FormTowns->LBConvention->Items->Add(SalatTimeConfig[i].Name);
//		FormSettings->LBConvention->Items->Add(SalatTimeConfig[i].Name);
//		}

	if (TownSelected>=0 && TownSelected<NTowns) {
									longitude=deg2rd*Towns[TownSelected]->longitude;
									latitude=deg2rd*Towns[TownSelected]->latitude;
									TimeZoneTown=Towns[TownSelected]->TimeZoneTown;
									DST=Towns[TownSelected]->DST;
									Convention=Towns[TownSelected]->Convention;
									if (Verbose) printf("Lieu actuel : \n");
									if (Verbose) 	printf("Lieu : %s, %s\n",Towns[TownSelected]->CountryName, Towns[TownSelected]->TownName);
									if (Verbose) 	printf("latitude=%s   longitude=%s\n", rd2degminsec(latitude, SS),rd2degminsec(longitude, SS2));
									if (Verbose) 	printf("Convention %d\n", Convention);
									}
				else			{
									printf("Error : Selected town out of range");
									return;
									}
}
//---------------------------------------------------------------------------
void WriteConfigFile()
{
char FileName[]="data.cfgw";
FILE * DataFile;
int i;
	if( (DataFile=fopen( FileName, "w")) == NULL )
			{
			printf("File open error %s\n", FileName);
			return;
			}
	fprintf(DataFile,"8 ------------------------------------------------------------------\n");
	fprintf(DataFile,"8 --------- Config file for Salat and Sun position program ---------\n");
	fprintf(DataFile,"8 ------------------------------------------------------------------\n");
	for (i=0; i<NConvention; i++)
		{
		fprintf(DataFile,"8 Convention Name\n");
		fprintf(DataFile, "5 %-9d \"%s\"\n", i, SalatTimeConfig[i].Name);
		fprintf(DataFile,"8 Convention AsrSahfi/Hanafi FajrTwilightAngle IshaTwilightAngle Sunrise/SetAngle Isha_is_Maghrib_plus xx mn ZuhrFixe ZuhrHour(h)\n");
		fprintf(DataFile, "3 %-9d  %-14d  %-16g  %-16g  %-15g  %-19d  %-4d  %-7d  %-15.7f\n", i, (SalatTimeConfig[i].AsrShafi ? 1:0),
						SalatTimeConfig[i].FajrTwilightAngle, SalatTimeConfig[i].IshaTwilightAngle,
						SalatTimeConfig[i].Sunrise_setAngle,
						(SalatTimeConfig[i].Isha_is_Maghrib_plus ? 1:0), SalatTimeConfig[i].Isha_is_Maghrib_plus_min,
						(SalatTimeConfig[i].ZuhrFixe ? 1:0), SalatTimeConfig[i].ZuhrFixeHour);
		fprintf(DataFile,"8 - Time (mn) to add to get Salat\n");
		fprintf(DataFile,"8 Convention Fajr     Chourouk Zuhr     Asr      Maghrib  Isha\n");
		fprintf(DataFile, "4 %-9d  %-7g  %-7g  %-7g  %-7g  %-7g  %-7g\n", i, SalatTimeConfig[i].SalatTimeAdjust.Fajr, SalatTimeConfig[i].SalatTimeAdjust.Chourouk,
						SalatTimeConfig[i].SalatTimeAdjust.Zuhr, SalatTimeConfig[i].SalatTimeAdjust.Asr,
						SalatTimeConfig[i].SalatTimeAdjust.Maghrib, SalatTimeConfig[i].SalatTimeAdjust.Isha);
		fprintf(DataFile,"8 ------------------------------------------------------------------\n");
		}
	fprintf(DataFile,"8 - sources :\n");
	fprintf(DataFile,"8 - http://www.ummah.net/astronomy/saltime/\n");
	fprintf(DataFile,"8 - http://moonsighting.com/faq_pt.html#F1\n");
	fprintf(DataFile,"8 - http://stjarnhimlen.se/comp/riset.html#3\n");
	fprintf(DataFile,"8 - http://www.jgiesen.de/SME/details/basics/meeus.htm#solar\n");
	fprintf(DataFile,"8 - http://www.fallingrain.com/world\n");
	fprintf(DataFile,"8 - http://maps.google.com/\n");
	fprintf(DataFile,"8 ------------------------------------------------------------------\n");
	fprintf(DataFile,"8 NumberOfTowns  TownSelected  Verbose\n");
	fprintf(DataFile, "1 %-13d  %-12d  %-7d\n", NTowns, TownSelected, Verbose);
	if (NTowns<=0) {
				printf ("Write config file Error : Invalid number of towns.\n");
				}
	fprintf(DataFile,"8 ------------------------------------------------------------------\n");
	fprintf(DataFile,"8 - Town location and TimeZone\n");
	fprintf(DataFile,"8 Country          Name             latitude    longitude   TimeZone DST Convention\n");
	for (i=0; i<NTowns; i++)
		{
		fprintf(DataFile, "2 %-15s  %-15s  %-10lf  %-10lf  %-7d  %-2d  %-2d\n", Towns[i]->CountryName, Towns[i]->TownName,
						Towns[i]->latitude, Towns[i]->longitude,
						Towns[i]->TimeZoneTown, Towns[i]->DST, Towns[i]->Convention);
		}
	fprintf(DataFile,"8 ------------------------------------------------------------------\n");
	fclose( DataFile);
}
//---------------------------------------------------------------------------
void Saveconfiguration1Click()
{
	WriteConfigFile();
}
//---------------------------------------------------------------------------
int CalculeNjdumois(int m, int annee)
{
int Nonbissextile=(annee-4*(int)(annee/4)+2)/3;  // 1 pour une anne commune et  0 pour une bissextile)
	if (m==1 || m==3 || m==5 || m==7
	 || m==8 || m==10 || m==12) 	return 31;
			else	{
						if (m==2) {if (Nonbissextile) return 28;
															else				return 29;
											}
								else  return 30;
				}
}
//---------------------------------------------------------------------------
int CalculeJour(double T) //  pertir du siecle Julien
{
double jour=T*36525+5;   
	return jour-7*(int)(jour/7);
}

//---------------------------------------------------------------------------
void About1Click()
{
char AboutSS[]="SalatTime v1.1\n\n\
Logiciel de calcul de la position du soleil\n\
et des heures de prires muslumanes\n\n\
Ceci est un \"doua3ware\" c'est--dire que,\n\
si vous tes musulman, merci de prier pour mon salut.\n\n\
Lotfi BAGHLI (c) 2006";
	printf( "%s", AboutSS);
}
//---------------------------------------------------------------------------
