//---------------------------------------------------------------------------

#define true 1
#define false 0
extern const double M_PI;
extern const double deg2rd;
extern const double rd2deg;
extern const double SolarSiderealCorrection;
//---------------------------------------------------------------------------
struct Astre  { double az,  h,      // coord. horizontal
                delta,  tau, // coord equatorial
                RA,                // ascension droite
								L;                //longitude rele
							};
#define idFajr 0
#define idChourouk 1
#define idZuhr 2
#define idAsr 3
#define idMaghrib 4
#define idIsha 5

#define NConvention 9
#define Namelenght 80
#define SSlenght 160

struct SalatTimeStruct  { double Fajr, Chourouk, Zuhr, Asr, Maghrib, Isha;};
struct DateUT  { int j, m, a; double h; // jour/mois/anne/heure.xxx
							};
struct Heure  { int ms, s, m, h;  // milisec, secondes/, minutes, heures
							};
struct TownData { char CountryName[Namelenght], TownName[Namelenght];
									double longitude, latitude;
									int TimeZoneTown, Convention, DST;
							};
struct SalatTimeConfigStruct {
					struct SalatTimeStruct SalatTimeAdjust;
					int AsrShafi, Isha_is_Maghrib_plus, ZuhrFixe;
					double FajrTwilightAngle, IshaTwilightAngle, Sunrise_setAngle;
					int Isha_is_Maghrib_plus_min;
					double ZuhrFixeHour;
					char Name[Namelenght];
					};
//---------------------------------------------------------------------------
	double JulianDay (int date, int month, int year, double UT);
	//double rang_du_jour (int date, int month, int year);
	double JulianCentury (int date, int month, int year, double UT);
	double SoleilLongitude( double T);
	void eclipticL2RA_delta( double T, double L, double * RA, double * delta);
	double TempsSideral( double T);
	void equatorial2horizontal( double beta, double tau, double delta, double * h, double * az);
	double rd2heure( double angle);
	int CalcTimeZone( int a, int m, int j, int DST, int TimeZoneTown);
	double heure2rd( double heure);
	char * rd2degminsec( double angle, char * SS);
	char * rd2hminsec( double angle, char * SS);
	char * h2hminsec( double h, char * SS);
	char * h2hmiarrondie( double h, char * SS);
	int CalculeNjdumois(int m, int annee);
	int CalculeJour(double T);
	struct DateUT GetDate();
	struct Heure GetHeure();
//---------------------------------------------------------------------------
	void ReadConfigFile();
	void WriteConfigFile();
	void ComputeSalatTime();
	void ButtonCalc_hazClick();
	void Oneday1Click();
	void Saveconfiguration1Click();
	void Onemounth1Click();
	void OnemounthCalculate(struct SalatTimeStruct * CalMensuel, int * daysMensuel, int Nj);
	void Oneyear1Click();
	void About1Click();
	void ComputeZuhrHour();
	int ComputeTwilightHour(int TypeSalat, double * SalatHour);
	void init();
 typedef struct TownData * pTownData;
//---------------------------------------------------------------------------
		extern struct Astre Soleil;
		extern struct SalatTimeStruct SalatTime, SalatTimeC;
		extern double JD, T,  // Jour Julien, Julien Century : T,
					theta0, theta,  // theta0 : temps sideral  Greenwich
					longitude, latitude;
		extern struct DateUT date; // date en jours
		extern struct Heure heure; // heure
		extern int TimeZone, TimeZoneTown, NTowns, TownSelected, Verbose, Convention;
		extern int DST, DSTApplies;
		extern struct SalatTimeConfigStruct SalatTimeConfig[NConvention];
		extern pTownData * Towns;
		extern char * Mounths[];
		extern char * Days[];
		extern char CountryName[Namelenght], TownName[Namelenght];

//---------------------------------------------------------------------------

